#! /usr/bin/env python

import subprocess

k = 32;
n = []
t_cpu = []
t_thrust = []
T_cpu = []
T_thrust = []

while k <= 100000000:
    with open("result", "w") as fOut:
        subprocess.call(['./install/exemple_thrust1', str(k)], stdout=fOut);
    with open("result") as fIn:
        for l in fIn:
            print(l[:-1])
            if "Thrust" in l:
                l = l.split()
                N = int(l[1])
                n.append(N)
                T_thrust.append(float(l[4]))
                t_thrust.append(float(l[8]))
            if "CPU" in l:
                l = l.split()
                T_cpu.append(float(l[4]))
                t_cpu.append(float(l[8]))
    k = k * 2

print(n)
print(T_cpu)
print(T_thrust)

try:
  import matplotlib.pyplot as plt
  use_graphics = True
except:
  use_graphics = False

if use_graphics:
    fig, (ax1, ax2) = plt.subplots(2, 1, figsize=(10,16))
    ax1.set_title("Compute time")
    ax1.plot(n, t_cpu, 'o-', label="CPU")
    ax1.plot(n, t_thrust, 'o-', label="GPU (Thrust)")
    ax1.set_xlabel("n (vector length)")
    ax1.set_ylabel('Time (s)')
    ax1.grid()
    ax1.set_yscale('log')
    ax1.set_xscale('log')

    ax2.set_title("Total time")
    ax2.plot(n, T_cpu, 'o-', label="CPU")
    ax2.plot(n, T_thrust, 'o-', label="GPU (Thrust)")
    ax2.set_xlabel("n (vector length)")
    ax2.set_ylabel('Time (s)')
    ax2.grid()
    ax2.set_yscale('log')
    ax2.set_xscale('log')
    plt.savefig("times.pdf")