#include <iostream>
#include <iomanip>
#include "calcul_pi.hxx"
#include "timer.hxx"

int main(int argc, char ** argv)
{
  long n = argc > 1 ? atol(argv[1]) : 100000000L;
  double p;

  Timer T_cpu;
  T_cpu.start();
  p = calcul_pi_cpu(n);
  T_cpu.stop();

  std::cerr << "Approximation de Pi : " << std::setprecision(10) << p 
            << " temps CPU    : " << T_cpu.elapsed() << std::endl;

  Timer T_cuda1;
  T_cuda1.start();
  p = calcul_pi_thrust1(n);
  T_cuda1.stop();

  std::cerr << "Approximation de Pi : " << std::setprecision(10) << p 
            << " temps CUDA 1 : " << T_cuda1.elapsed() << std::endl;

  Timer T_cuda2;
  T_cuda2.start();
  p = calcul_pi_thrust2(n);
  T_cuda2.stop();

  std::cerr << "Approximation de Pi : " << std::setprecision(10) << p 
            << " temps CUDA 2 : " << T_cuda2.elapsed() << std::endl;
  return 0;
}
